Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/IOM/iom.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/IOM/iom.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/IOM/iom.F90	(revision 9814)
@@ -1285,9 +1285,9 @@
                !--- overlap areas and extra hallows (mpp)
                IF(     PRESENT(pv_r2d) .AND. idom /= jpdom_unknown ) THEN
-                  CALL lbc_lnk( pv_r2d,'Z',-999.,'no0' )
+                  CALL lbc_lnk("iom",pv_r2d,'Z',-999.,'no0' )
                ELSEIF( PRESENT(pv_r3d) .AND. idom /= jpdom_unknown ) THEN
                   ! this if could be simplified with the new lbc_lnk that works with any size of the 3rd dimension
                   IF( icnt(3) == inlev ) THEN
-                     CALL lbc_lnk( pv_r3d,'Z',-999.,'no0' )
+                     CALL lbc_lnk("iom",pv_r3d,'Z',-999.,'no0' )
                   ELSE   ! put some arbitrary value (a call to lbc_lnk will be done later...)
                      DO jj = nlcj+1, jpj   ;   pv_r3d(1:nlci, jj, :) = pv_r3d(1:nlci, nlej, :)   ;   END DO
@@ -1314,5 +1314,5 @@
             CALL xios_recv_field( trim(cdvar), pv_r3d)
             IF(idom /= jpdom_unknown ) then
-                CALL lbc_lnk( pv_r3d,'Z',-999.,'no0' )
+                CALL lbc_lnk("iom",pv_r3d,'Z',-999.,'no0' )
             ENDIF
          ELSEIF( PRESENT(pv_r2d) ) THEN
@@ -1321,5 +1321,5 @@
             CALL xios_recv_field( trim(cdvar), pv_r2d)
             IF(idom /= jpdom_unknown ) THEN
-                CALL lbc_lnk(pv_r2d,'Z',-999.,'no0')
+                CALL lbc_lnk("iom",pv_r2d,'Z',-999.,'no0')
             ENDIF
          ELSEIF( PRESENT(pv_r1d) ) THEN
@@ -1336,6 +1336,6 @@
 !some final adjustments
       ! C1D case : always call lbc_lnk to replicate the central value over the whole 3X3 domain
-      IF( lk_c1d .AND. PRESENT(pv_r2d) )   CALL lbc_lnk( pv_r2d,'Z',1. )
-      IF( lk_c1d .AND. PRESENT(pv_r3d) )   CALL lbc_lnk( pv_r3d,'Z',1. )
+      IF( lk_c1d .AND. PRESENT(pv_r2d) )   CALL lbc_lnk("iom",pv_r2d,'Z',1. )
+      IF( lk_c1d .AND. PRESENT(pv_r3d) )   CALL lbc_lnk("iom",pv_r3d,'Z',1. )
 
       !--- Apply scale_factor and offset
@@ -1918,6 +1918,6 @@
          SELECT CASE ( cdgrd )
          CASE('T')   ;   zmask(:,:,:)       = tmask(:,:,:)
-         CASE('U')   ;   zmask(2:jpim1,:,:) = tmask(2:jpim1,:,:) + tmask(3:jpi,:,:)   ;   CALL lbc_lnk( zmask, 'U', 1. )
-         CASE('V')   ;   zmask(:,2:jpjm1,:) = tmask(:,2:jpjm1,:) + tmask(:,3:jpj,:)   ;   CALL lbc_lnk( zmask, 'V', 1. )
+         CASE('U')   ;   zmask(2:jpim1,:,:) = tmask(2:jpim1,:,:) + tmask(3:jpi,:,:)   ;   CALL lbc_lnk("iom",zmask, 'U', 1. )
+         CASE('V')   ;   zmask(:,2:jpjm1,:) = tmask(:,2:jpjm1,:) + tmask(:,3:jpj,:)   ;   CALL lbc_lnk("iom",zmask, 'V', 1. )
          CASE('W')   ;   zmask(:,:,2:jpk  ) = tmask(:,:,1:jpkm1) + tmask(:,:,2:jpk)   ;   zmask(:,:,1) = tmask(:,:,1)
          END SELECT
@@ -1962,5 +1962,5 @@
       !
       z_fld(:,:) = 1._wp
-      CALL lbc_lnk( z_fld, cdgrd, -1. )    ! Working array for location of northfold
+      CALL lbc_lnk("iom",z_fld, cdgrd, -1. )    ! Working array for location of northfold
       !
       ! Cell vertices that can be defined
@@ -1980,6 +1980,6 @@
       ! Cell vertices on boundries
       DO jn = 1, 4
-         CALL lbc_lnk( z_bnds(jn,:,:,1), cdgrd, 1., pval=999._wp )
-         CALL lbc_lnk( z_bnds(jn,:,:,2), cdgrd, 1., pval=999._wp )
+         CALL lbc_lnk("iom",z_bnds(jn,:,:,1), cdgrd, 1., pval=999._wp )
+         CALL lbc_lnk("iom",z_bnds(jn,:,:,2), cdgrd, 1., pval=999._wp )
       END DO
       !
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lbc_lnk_multi_generic.h90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lbc_lnk_multi_generic.h90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lbc_lnk_multi_generic.h90	(revision 9814)
@@ -14,5 +14,5 @@
 #   define PTR_ptab              pt4d
 #endif
-   SUBROUTINE ROUTINE_MULTI( pt1, cdna1, psgn1, pt2, cdna2, psgn2, pt3, cdna3, psgn3   &
+   SUBROUTINE ROUTINE_MULTI( rname, pt1, cdna1, psgn1, pt2, cdna2, psgn2, pt3, cdna3, psgn3   &
       &                    , pt4, cdna4, psgn4, pt5, cdna5, psgn5, pt6, cdna6, psgn6   &
       &                    , pt7, cdna7, psgn7, pt8, cdna8, psgn8, pt9, cdna9, psgn9, cd_mpp, pval)
@@ -31,4 +31,5 @@
       CHARACTER(len=1) , DIMENSION(9) ::   cdna_ptr    ! nature of ptab_ptr grid-points
       REAL(wp)         , DIMENSION(9) ::   psgn_ptr    ! sign used across the north fold boundary
+      CHARACTER(len=*),             INTENT(in   ) ::   rname       ! name of the calling subroutine
       !!---------------------------------------------------------------------
       !
@@ -48,5 +49,5 @@
       IF( PRESENT(psgn9) )   CALL ROUTINE_LOAD( pt9, cdna9, psgn9, ptab_ptr, cdna_ptr, psgn_ptr, kfld )
       !
-      CALL lbc_lnk_ptr( ptab_ptr, cdna_ptr, psgn_ptr, kfld, cd_mpp, pval )
+      CALL lbc_lnk_ptr( rname, ptab_ptr, cdna_ptr, psgn_ptr, kfld, cd_mpp, pval )
       !
    END SUBROUTINE ROUTINE_MULTI
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lbclnk.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lbclnk.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lbclnk.F90	(revision 9814)
@@ -50,4 +50,7 @@
    PUBLIC   lbc_lnk_icb   ! iceberg lateral boundary conditions
 
+   PUBLIC   simulated_lbc_lnk
+
+   REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE, SAVE ::   zdummy_halo
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
@@ -325,4 +328,87 @@
 #  undef DIM_4d
 
+   SUBROUTINE simulated_lbc_lnk ()
+
+    INTEGER :: i
+
+     IF (.NOT. ALLOCATED(zdummy_halo) ) THEN
+        i = MAXVAL(icomm_sequence(:,2))
+        ALLOCATE( zdummy_halo(jpi,jpj,jpk,i))
+        zdummy_halo(:,:,:,:) = 0._wp
+     ENDIF
+
+     DO i = 1, n_sequence
+        ! unbufferize data
+     !   zdummy_halo(:,:,:,:) = zdummy_halo(:,:,:,:) + 1.
+        IF ( icomm_sequence(i,1) == 1 ) THEN
+           SELECT CASE ( icomm_sequence(i,2) )
+           CASE (1)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1)  , 'U', -1. )
+           CASE (2)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1) , 'U', -1. , zdummy_halo(:,:,1,2)  , 'U', -1. )
+           CASE (3)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1) , 'U', -1. , zdummy_halo(:,:,1,2)  , 'U', -1. ,zdummy_halo(:,:,1,3) , 'U', -1.)
+           CASE (4)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1) , 'U', -1. , zdummy_halo(:,:,1,2)  , 'U', -1. ,zdummy_halo(:,:,1,3) , 'U', -1.,zdummy_halo(:,:,1,4) , 'U', -1.)
+           CASE (5)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1) , 'U', -1. , zdummy_halo(:,:,1,2)  , 'U', -1. ,zdummy_halo(:,:,1,3) , 'U', -1.,zdummy_halo(:,:,1,4) , 'U', -1.,zdummy_halo(:,:,1,5) , 'U', -1.)
+           CASE (6)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1) , 'U', -1. , zdummy_halo(:,:,1,2)  , 'U', -1. ,zdummy_halo(:,:,1,3) , 'U', -1.,zdummy_halo(:,:,1,4) , 'U', -1.,zdummy_halo(:,:,1,5) , 'U', -1.,zdummy_halo(:,:,1,6) , 'U', -1.)
+           CASE (7)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1), 'U', -1., zdummy_halo(:,:,1,2), 'U', -1., & 
+                                 zdummy_halo(:,:,1,3), 'U', -1., zdummy_halo(:,:,1,4), 'U', -1., &
+                                 zdummy_halo(:,:,1,5), 'U', -1., zdummy_halo(:,:,1,6), 'U', -1., &
+                                 zdummy_halo(:,:,1,7), 'U', -1.)
+           CASE (8)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1), 'U', -1., zdummy_halo(:,:,1,2), 'U', -1., & 
+                                 zdummy_halo(:,:,1,3), 'U', -1., zdummy_halo(:,:,1,4), 'U', -1., &
+                                 zdummy_halo(:,:,1,5), 'U', -1., zdummy_halo(:,:,1,6), 'U', -1., &
+                                 zdummy_halo(:,:,1,7), 'U', -1., zdummy_halo(:,:,1,8), 'U', -1.)
+           CASE (9)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,1,1), 'U', -1., zdummy_halo(:,:,1,2), 'U', -1., & 
+                                 zdummy_halo(:,:,1,3), 'U', -1., zdummy_halo(:,:,1,4), 'U', -1., &
+                                 zdummy_halo(:,:,1,5), 'U', -1., zdummy_halo(:,:,1,6), 'U', -1., &
+                                 zdummy_halo(:,:,1,7), 'U', -1., zdummy_halo(:,:,1,8), 'U', -1., &
+                                 zdummy_halo(:,:,1,9), 'U', -1.)
+           CASE DEFAULT
+              WRITE(6,*) ' Warning (simulated_lbc_lnk): multi array dimension > 9, not transmitted '
+           END SELECT
+        ELSE
+           SELECT CASE ( icomm_sequence(i,2) )
+           CASE (1)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1) , 'U', -1.)
+           CASE (2)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1) , 'U', -1. , zdummy_halo(:,:,:,2)  , 'U', -1.)
+           CASE (3)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1) , 'U', -1. , zdummy_halo(:,:,:,2)  , 'U', -1. ,zdummy_halo(:,:,:,3) , 'U', -1.)
+           CASE (4)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1) , 'U', -1. , zdummy_halo(:,:,:,2)  , 'U', -1. ,zdummy_halo(:,:,:,3) , 'U', -1.,zdummy_halo(:,:,:,4) , 'U', -1.)
+           CASE (5)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1) , 'U', -1. , zdummy_halo(:,:,:,2)  , 'U', -1. ,zdummy_halo(:,:,:,3) , 'U', -1.,zdummy_halo(:,:,:,4) , 'U', -1.,zdummy_halo(:,:,:,5) , 'U', -1.)
+           CASE (6)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1) , 'U', -1. , zdummy_halo(:,:,:,2)  , 'U', -1. ,zdummy_halo(:,:,:,3) , 'U', -1.,zdummy_halo(:,:,:,4) , 'U', -1.,zdummy_halo(:,:,:,5) , 'U', -1.,zdummy_halo(:,:,:,6) , 'U', -1.)
+           CASE (7)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1), 'U', -1., zdummy_halo(:,:,:,2), 'U', -1., & 
+                                 zdummy_halo(:,:,:,3), 'U', -1., zdummy_halo(:,:,:,4), 'U', -1., &
+                                 zdummy_halo(:,:,:,5), 'U', -1., zdummy_halo(:,:,:,6), 'U', -1., &
+                                 zdummy_halo(:,:,:,7), 'U', -1.)
+           CASE (8)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1), 'U', -1., zdummy_halo(:,:,:,2), 'U', -1., & 
+                                 zdummy_halo(:,:,:,3), 'U', -1., zdummy_halo(:,:,:,4), 'U', -1., &
+                                 zdummy_halo(:,:,:,5), 'U', -1., zdummy_halo(:,:,:,6), 'U', -1., &
+                                 zdummy_halo(:,:,:,7), 'U', -1., zdummy_halo(:,:,:,8), 'U', -1.)
+           CASE (9)
+              CALL lbc_lnk_multi("simulated_lbc_lnk",zdummy_halo(:,:,:,1), 'U', -1., zdummy_halo(:,:,:,2), 'U', -1., & 
+                                 zdummy_halo(:,:,:,3), 'U', -1., zdummy_halo(:,:,:,4), 'U', -1., &
+                                 zdummy_halo(:,:,:,5), 'U', -1., zdummy_halo(:,:,:,6), 'U', -1., &
+                                 zdummy_halo(:,:,:,7), 'U', -1., zdummy_halo(:,:,:,8), 'U', -1., &
+                                 zdummy_halo(:,:,:,9), 'U', -1.)
+           CASE DEFAULT
+              WRITE(6,*) ' Warning (simulated_lbc_lnk): multi 3D array dimension > 9, not transmitted '
+           END SELECT
+        ENDIF
+     ENDDO
+
+   END SUBROUTINE simulated_lbc_lnk
    !!======================================================================
 END MODULE lbclnk
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lib_mpp.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lib_mpp.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/lib_mpp.F90	(revision 9814)
@@ -1625,5 +1625,5 @@
     ELSE
        IF ( ncom_stp > nit000 ) tac_wt = tac_wt + MPI_Wtime() - tic_wt
-       IF ( ( ncom_stp == ( nitend - 1 ) ) .AND. l_write_wt ) then
+       IF ( ( ncom_stp == ( nitend - nn_comm_mod ) ) .AND. l_write_wt ) then
           WRITE(6,'(A20,F11.6,A15,I8)') 'Computing time : ',tac_ct,' on MPI rank : ', narea
           WRITE(6,'(A20,F11.6,A15,I8)') 'Waiting time : ',tac_wt,' on MPI rank : ', narea
@@ -1838,4 +1838,7 @@
    END SUBROUTINE mppmax_real_multiple
 
+   SUBROUTINE simulated_lbc_lnk ()
+      WRITE(*,*) 'simulated_lbc_lnk: You should not have seen this print! error?'
+   END SUBROUTINE simulated_lbc_lnk ()
 #endif
 
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mpp_lnk_generic.h90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mpp_lnk_generic.h90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mpp_lnk_generic.h90	(revision 9814)
@@ -46,8 +46,8 @@
 
 #if defined MULTI
-   SUBROUTINE ROUTINE_LNK( ptab, cd_nat, psgn, kfld, cd_mpp, pval )
+   SUBROUTINE ROUTINE_LNK( rname, ptab, cd_nat, psgn, kfld, cd_mpp, pval )
       INTEGER                     , INTENT(in   ) ::   kfld        ! number of pt3d arrays
 #else
-   SUBROUTINE ROUTINE_LNK( ptab, cd_nat, psgn      , cd_mpp, pval )
+   SUBROUTINE ROUTINE_LNK( rname, ptab, cd_nat, psgn      , cd_mpp, pval )
 #endif
       ARRAY_TYPE(:,:,:,:,:)                                        ! array or pointer of arrays on which the boundary condition is applied
@@ -56,4 +56,5 @@
       CHARACTER(len=3), OPTIONAL  , INTENT(in   ) ::   cd_mpp      ! fill the overlap area only
       REAL(wp)        , OPTIONAL  , INTENT(in   ) ::   pval        ! background value (used at closed boundaries)
+      CHARACTER(len=*),             INTENT(in   ) ::   rname       ! name of the calling subroutine
       !
       INTEGER  ::    ji,  jj,  jk,  jl, jh, jf   ! dummy loop indices
@@ -155,20 +156,24 @@
          icomm_sequence(n_sequence,2) = ipf
          ! write(6,'(A,6I4)') 'size comm ', nn_hls, jpi, jpj, ipk, ipl, ipf
-      ELSE IF ( mpprank == 0 .AND. ncom_stp == (nit000+1) .AND. l_print_comm_report ) THEN
-         write(6,*) 'Communication pattern report : '
-         write(6,*) ' '
-         write(6,'(A,I3)') ' Exchanged halos : ', n_sequence
-         jj = 0; jk = 0; jf = 0; jh = 0
-         DO ji = 1, n_sequence
-           IF ( icomm_sequence(ji,1) .gt. 1 ) jk = jk + 1
-           IF ( icomm_sequence(ji,2) .gt. 1 ) jf = jf + 1
-           IF ( icomm_sequence(ji,1) .gt. 1 .AND. icomm_sequence(ji,2) .gt. 1 ) jj = jj + 1
-           jh = MAX (jh, icomm_sequence(ji,1)*icomm_sequence(ji,2))
-         END DO
-         write(6,'(A,I3)') ' 3D Exchanged halos : ', jk
-         write(6,'(A,I3)') ' Multi arrays exchanged halos : ', jf
-         write(6,'(A,I3)') '   from which 3D : ', jj
-         write(6,'(A,I10)') ' array max size : ', jh*jpi*jpj
-         l_print_comm_report = .FALSE.
+      ELSE IF ( mpprank == 0 .AND. ncom_stp == (nit000+1) ) THEN
+         IF ( l_print_comm_report ) THEN
+            write(6,*) 'Communication pattern report : '
+            write(6,*) ' '
+            write(6,'(A,I3)') ' Exchanged halos : ', n_sequence
+            jj = 0; jk = 0; jf = 0; jh = 0
+            DO ji = 1, n_sequence
+              IF ( icomm_sequence(ji,1) .gt. 1 ) jk = jk + 1
+              IF ( icomm_sequence(ji,2) .gt. 1 ) jf = jf + 1
+              IF ( icomm_sequence(ji,1) .gt. 1 .AND. icomm_sequence(ji,2) .gt. 1 ) jj = jj + 1
+              jh = MAX (jh, icomm_sequence(ji,1)*icomm_sequence(ji,2))
+            END DO
+            write(6,'(A,I3)') ' 3D Exchanged halos : ', jk
+            write(6,'(A,I3)') ' Multi arrays exchanged halos : ', jf
+            write(6,'(A,I3)') '   from which 3D : ', jj
+            write(6,'(A,I10)') ' array max size : ', jh*jpi*jpj
+            write(6,*) ' '
+            l_print_comm_report = .FALSE.
+         END IF
+         write(6,'(A19,A)') 'calling subroutine ', TRIM(rname)
       END IF
       !
@@ -177,4 +182,7 @@
          CALL tic_tac(.TRUE.)
          !
+         IF ( TRIM(rname) == "simulated_lbc_lnk" ) THEN
+            zt3we = zt3we + 1. ; zt3ew = zt3ew + 1.
+         ENDIF
          SELECT CASE ( nbondi )
          CASE ( -1 )
@@ -255,4 +263,7 @@
       !
       IF (ncom_stp <= ( nit000 + 1 ) .or. mod(ncom_stp,nn_comm_mod) == 0 ) THEN
+         IF ( TRIM(rname) == "simulated_lbc_lnk" ) THEN
+            zt3sn = zt3sn + 1. ; zt3ns = zt3ns + 1.
+         ENDIF
  
          SELECT CASE ( nbondj )
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mpp_nfd_generic.h90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mpp_nfd_generic.h90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mpp_nfd_generic.h90	(revision 9814)
@@ -110,4 +110,8 @@
             END DO
          END DO
+         !
+         IF (ncom_stp <= ( nit000 + 1 ) .or. mod(ncom_stp,nn_comm_mod) == 0 ) THEN
+         ! start waiting time measurement
+         CALL tic_tac(.TRUE.)
          !
          DO jr = 1, nsndto
@@ -157,4 +161,8 @@
             END DO
          ENDIF
+         ! stop waiting time measurement
+         CALL tic_tac(.FALSE.)
+         ENDIF
+         !
          DO jf = 1, ipf
             CALL lbc_nfd_nogather( ztabl(:,:,:,:,jf), ztabr(:,:,:,:,jf), cd_nat LBC_ARG, psgn LBC_ARG )   ! North fold boundary condition
@@ -179,6 +187,15 @@
          ALLOCATE( znorthgloio(jpimax,4,ipk,ipl,ipf,jpni) )
          !
-         CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
-            &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         IF (ncom_stp <= ( nit000 + 1 ) .or. mod(ncom_stp,nn_comm_mod) == 0 ) THEN
+         ! start waiting time measurement
+         CALL tic_tac(.TRUE.)
+         IF (ncom_stp <= ( nit000 + 1 ) .or. mod(ncom_stp,nn_comm_mod) == 0 ) THEN
+            CALL MPI_ALLGATHER( znorthloc  , itaille, MPI_DOUBLE_PRECISION,                &
+               &                znorthgloio, itaille, MPI_DOUBLE_PRECISION, ncomm_north, ierr )
+         ENDIF
+         !
+         ! stop waiting time measurement
+         CALL tic_tac(.FALSE.)
+         ENDIF
          !
          ztab(:,:,:,:,:) = 0._wp
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mppini.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mppini.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LBC/mppini.F90	(revision 9814)
@@ -62,5 +62,5 @@
       jpi    = jpiglo
       jpj    = jpjglo
-      jpk    = jpjglo
+      jpk    = jpkglo
       jpim1  = jpi-1                                            ! inner domain indices
       jpjm1  = jpj-1                                            !   "           "
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfc1d_c2d.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfc1d_c2d.F90	(revision 9814)
@@ -87,5 +87,5 @@
             END DO
          END DO
-         CALL lbc_lnk( pah2, 'F', 1. )   ! Lateral boundary conditions
+         CALL lbc_lnk("ldfc1d_c2d",pah2, 'F', 1. )   ! Lateral boundary conditions
          !
       CASE( 'TRA' )                     ! U- and V-points (zdep1 & 2 are an approximation in zps-coord.)
@@ -101,5 +101,5 @@
          END DO
          ! Lateral boundary conditions
-         CALL lbc_lnk_multi( pah1, 'U', 1. , pah2, 'V', 1. )   
+         CALL lbc_lnk_multi("ldfc1d_c2d",pah1, 'U', 1. , pah2, 'V', 1. )   
          !
       CASE DEFAULT                        ! error
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfdyn.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfdyn.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfdyn.F90	(revision 9814)
@@ -399,5 +399,5 @@
          ENDIF
          !
-         CALL lbc_lnk_multi( ahmt, 'T', 1.,  ahmf, 'F', 1. )
+         CALL lbc_lnk_multi("ldfdyn",ahmt, 'T', 1.,  ahmf, 'F', 1. )
          !
          !
@@ -477,5 +477,5 @@
          ENDIF
          !
-         CALL lbc_lnk_multi( ahmt, 'T', 1. , ahmf, 'F', 1. )
+         CALL lbc_lnk_multi("ldfdyn",ahmt, 'T', 1. , ahmf, 'F', 1. )
          !
       END SELECT
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfslp.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfslp.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldfslp.F90	(revision 9814)
@@ -232,5 +232,5 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( zwz, 'U', -1.,  zww, 'V', -1. )      ! lateral boundary conditions
+      CALL lbc_lnk_multi("ldfslp",zwz, 'U', -1.,  zww, 'V', -1. )      ! lateral boundary conditions
       !
       !                                            !* horizontal Shapiro filter
@@ -314,5 +314,5 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( zwz, 'T', -1.,  zww, 'T', -1. )      ! lateral boundary conditions
+      CALL lbc_lnk_multi("ldfslp",zwz, 'T', -1.,  zww, 'T', -1. )      ! lateral boundary conditions
       !
       !                                           !* horizontal Shapiro filter
@@ -363,5 +363,5 @@
       ! IV. Lateral boundary conditions
       ! ===============================
-      CALL lbc_lnk_multi( uslp , 'U', -1. , vslp , 'V', -1. , wslpi, 'W', -1., wslpj, 'W', -1. )
+      CALL lbc_lnk_multi("ldfslp",uslp , 'U', -1. , vslp , 'V', -1. , wslpi, 'W', -1., wslpj, 'W', -1. )
 
       IF(ln_ctl) THEN
@@ -611,5 +611,5 @@
       wslp2(:,:,1) = 0._wp                ! force the surface wslp to zero
 
-      CALL lbc_lnk( wslp2, 'W', 1. )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
+      CALL lbc_lnk("ldfslp",wslp2, 'W', 1. )      ! lateral boundary confition on wslp2 only   ==>>> gm : necessary ? to be checked
       !
       IF( ln_timing )   CALL timing_stop('ldf_slp_triad')
@@ -725,5 +725,5 @@
       END DO
       !!gm this lbc_lnk should be useless....
-      CALL lbc_lnk_multi( uslpml , 'U', -1. , vslpml , 'V', -1. , wslpiml, 'W', -1. , wslpjml, 'W', -1. ) 
+      CALL lbc_lnk_multi("ldfslp",uslpml , 'U', -1. , vslpml , 'V', -1. , wslpiml, 'W', -1. , wslpjml, 'W', -1. ) 
       !
    END SUBROUTINE ldf_slp_mxl
@@ -793,5 +793,5 @@
 !               END DO
 !            END DO
-!            CALL lbc_lnk_multi( uslp , 'U', -1. ; CALL lbc_lnk( vslp , 'V', -1.,  wslpi, 'W', -1.,  wslpj, 'W', -1. )
+!            CALL lbc_lnk_multi("ldfslp",uslp , 'U', -1. ; CALL lbc_lnk("ldfslp",vslp , 'V', -1.,  wslpi, 'W', -1.,  wslpj, 'W', -1. )
 !!gm         ENDIF
       ENDIF
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldftra.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldftra.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/LDF/ldftra.F90	(revision 9814)
@@ -707,5 +707,5 @@
          END DO
       END DO
-      CALL lbc_lnk( zaeiw(:,:), 'W', 1. )       ! lateral boundary condition
+      CALL lbc_lnk("ldftra",zaeiw(:,:), 'W', 1. )       ! lateral boundary condition
       !               
       DO jj = 2, jpjm1                          !== aei at u- and v-points  ==!
@@ -715,5 +715,5 @@
          END DO 
       END DO 
-      CALL lbc_lnk_multi( paeiu(:,:,1), 'U', 1. , paeiv(:,:,1), 'V', 1. )      ! lateral boundary condition
+      CALL lbc_lnk_multi("ldftra",paeiu(:,:,1), 'U', 1. , paeiv(:,:,1), 'V', 1. )      ! lateral boundary condition
 
       DO jk = 2, jpkm1                          !==  deeper values equal the surface one  ==!
@@ -821,5 +821,5 @@
 !!gm     to be redesigned....   
       !                                                  !==  eiv stream function: output  ==!
-      CALL lbc_lnk_multi( psi_uw, 'U', -1. , psi_vw, 'V', -1. )
+      CALL lbc_lnk_multi("ldftra",psi_uw, 'U', -1. , psi_vw, 'V', -1. )
       !
 !!gm      CALL iom_put( "psi_eiv_uw", psi_uw )                 ! output
@@ -848,5 +848,5 @@
          END DO
       END DO
-      CALL lbc_lnk( zw3d, 'T', 1. )      ! lateral boundary condition
+      CALL lbc_lnk("ldftra",zw3d, 'T', 1. )      ! lateral boundary condition
       CALL iom_put( "woce_eiv", zw3d )
       !
@@ -865,6 +865,6 @@
            END DO
         END DO
-        CALL lbc_lnk( zw2d, 'U', -1. )
-        CALL lbc_lnk( zw3d, 'U', -1. )
+        CALL lbc_lnk("ldftra",zw2d, 'U', -1. )
+        CALL lbc_lnk("ldftra",zw3d, 'U', -1. )
         CALL iom_put( "ueiv_heattr"  , zztmp * zw2d )                  ! heat transport in i-direction
         CALL iom_put( "ueiv_heattr3d", zztmp * zw3d )                  ! heat transport in i-direction
@@ -881,5 +881,5 @@
          END DO
       END DO
-      CALL lbc_lnk( zw2d, 'V', -1. )
+      CALL lbc_lnk("ldftra",zw2d, 'V', -1. )
       CALL iom_put( "veiv_heattr", zztmp * zw2d )                  !  heat transport in j-direction
       CALL iom_put( "veiv_heattr", zztmp * zw3d )                  !  heat transport in j-direction
@@ -900,6 +900,6 @@
            END DO
         END DO
-        CALL lbc_lnk( zw2d, 'U', -1. )
-        CALL lbc_lnk( zw3d, 'U', -1. )
+        CALL lbc_lnk("ldftra",zw2d, 'U', -1. )
+        CALL lbc_lnk("ldftra",zw3d, 'U', -1. )
         CALL iom_put( "ueiv_salttr", zztmp * zw2d )                  ! salt transport in i-direction
         CALL iom_put( "ueiv_salttr3d", zztmp * zw3d )                  ! salt transport in i-direction
@@ -916,5 +916,5 @@
          END DO
       END DO
-      CALL lbc_lnk( zw2d, 'V', -1. )
+      CALL lbc_lnk("ldftra",zw2d, 'V', -1. )
       CALL iom_put( "veiv_salttr", zztmp * zw2d )                  !  salt transport in j-direction
       CALL iom_put( "veiv_salttr", zztmp * zw3d )                  !  salt transport in j-direction
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/cpl_oasis3.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/cpl_oasis3.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/cpl_oasis3.F90	(revision 9814)
@@ -410,5 +410,5 @@
          !--- Fill the overlap areas and extra hallows (mpp)
          !--- check periodicity conditions (all cases)
-         IF( .not. llfisrt )   CALL lbc_lnk( pdata(:,:,jc), srcv(kid)%clgrid, srcv(kid)%nsgn )   
+         IF( .not. llfisrt )   CALL lbc_lnk("cpl_oasis3",pdata(:,:,jc), srcv(kid)%clgrid, srcv(kid)%nsgn )   
  
       ENDDO
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/fldread.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/fldread.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/fldread.F90	(revision 9814)
@@ -669,8 +669,8 @@
                IF( sdjf%ln_tint ) THEN
                   CALL iom_get( sdjf%num, sdjf%clvar, sdjf%fdta(2,2,1,2), sdjf%nrec_a(1) )
-                  CALL lbc_lnk( sdjf%fdta(:,:,1,2),'Z',1. )
+                  CALL lbc_lnk("fldread",sdjf%fdta(:,:,1,2),'Z',1. )
                ELSE
                   CALL iom_get( sdjf%num, sdjf%clvar, sdjf%fnow(2,2,1  ), sdjf%nrec_a(1) )
-                  CALL lbc_lnk( sdjf%fnow(:,:,1  ),'Z',1. )
+                  CALL lbc_lnk("fldread",sdjf%fnow(:,:,1  ),'Z',1. )
                ENDIF
             ELSE
@@ -683,8 +683,8 @@
                IF( sdjf%ln_tint ) THEN
                   CALL iom_get( sdjf%num, jpdom_unknown, sdjf%clvar, sdjf%fdta(2,2,:,2), sdjf%nrec_a(1) )
-                  CALL lbc_lnk( sdjf%fdta(:,:,:,2),'Z',1. )
+                  CALL lbc_lnk("fldread",sdjf%fdta(:,:,:,2),'Z',1. )
                ELSE
                   CALL iom_get( sdjf%num, jpdom_unknown, sdjf%clvar, sdjf%fnow(2,2,:  ), sdjf%nrec_a(1) )
-                  CALL lbc_lnk( sdjf%fnow(:,:,:  ),'Z',1. )
+                  CALL lbc_lnk("fldread",sdjf%fnow(:,:,:  ),'Z',1. )
                ENDIF
             ELSE
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/geo2ocean.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/geo2ocean.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/geo2ocean.F90	(revision 9814)
@@ -280,5 +280,5 @@
       ! =========================== !
       !           ! lateral boundary cond.: T-, U-, V-, F-pts, sgn
-      CALL lbc_lnk_multi( gcost, 'T', -1., gsint, 'T', -1., gcosu, 'U', -1., gsinu, 'U', -1., & 
+      CALL lbc_lnk_multi("geo2ocean",gcost, 'T', -1., gsint, 'T', -1., gcosu, 'U', -1., gsinu, 'U', -1., & 
                       &   gcosv, 'V', -1., gsinv, 'V', -1., gcosf, 'F', -1., gsinf, 'F', -1.  )
       !
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/sbc_oce.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/sbc_oce.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/sbc_oce.F90	(revision 9814)
@@ -216,5 +216,5 @@
          END DO
       END DO
-      CALL lbc_lnk( wndm(:,:) , 'T', 1. )
+      CALL lbc_lnk("sbc_oce",wndm(:,:) , 'T', 1. )
       !
    END SUBROUTINE sbc_tau2wnd
Index: /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/sbcblk.F90	(revision 9813)
+++ /NEMO/branches/2018/dev_r9759_HPC09_ESIWACE/src/OCE/SBC/sbcblk.F90	(revision 9814)
@@ -407,5 +407,5 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( zwnd_i, 'T', -1., zwnd_j, 'T', -1. )
+      CALL lbc_lnk_multi("sbcblk",zwnd_i, 'T', -1., zwnd_j, 'T', -1. )
       ! ... scalar wind ( = | U10m - U_oce | ) at T-point (masked)
       wndm(:,:) = SQRT(  zwnd_i(:,:) * zwnd_i(:,:)   &
@@ -485,5 +485,5 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( utau, 'U', -1., vtau, 'V', -1. )
+      CALL lbc_lnk_multi("sbcblk",utau, 'U', -1., vtau, 'V', -1. )
 
       !  Turbulent fluxes over ocean
@@ -732,5 +732,5 @@
             END DO
          END DO
-         CALL lbc_lnk( wndm_ice, 'T',  1. )
+         CALL lbc_lnk("sbcblk",wndm_ice, 'T',  1. )
          !
       CASE( 'C' )                  ! C-grid ice dynamics :   U & V-points (same as ocean)
@@ -742,5 +742,5 @@
             END DO
          END DO
-         CALL lbc_lnk( wndm_ice, 'T',  1. )
+         CALL lbc_lnk("sbcblk",wndm_ice, 'T',  1. )
          !
       END SELECT
@@ -784,5 +784,5 @@
             END DO
          END DO
-         CALL lbc_lnk_multi( utau_ice, 'I', -1., vtau_ice, 'I', -1. )
+         CALL lbc_lnk_multi("sbcblk",utau_ice, 'I', -1., vtau_ice, 'I', -1. )
          !
       CASE( 'C' )                  ! C-grid ice dynamics :   U & V-points (same as ocean)
@@ -795,5 +795,5 @@
             END DO
          END DO
-         CALL lbc_lnk_multi( utau_ice, 'U', -1., vtau_ice, 'V', -1. )
+         CALL lbc_lnk_multi("sbcblk",utau_ice, 'U', -1., vtau_ice, 'V', -1. )
          !
       END SELECT
@@ -1218,5 +1218,5 @@
          END DO
       END DO
-      CALL lbc_lnk_multi( Cd, 'T',  1., Ch, 'T', 1. )
+      CALL lbc_lnk_multi("sbcblk",Cd, 'T',  1., Ch, 'T', 1. )
       !
    END SUBROUTINE Cdn10_Lupkes2015
